main/urls.py
from django.urls import path

from main.views import index, subject_page, lesson_page

app_name = 'main'

urlpatterns = [
    path('subject/<int:pk>/', subject_page, name='subject-page'),  # дефіс в імені
    path('lesson/<int:pk>/', lesson_page, name='lesson-page'),  # дефіс в імені
    path('', index, name='home'),
]

project/urls.py
from django.conf import settings
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from django.utils.translation import gettext_lazy as _


urlpatterns = static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT) + [
    path('accounts/', include('allauth.urls')),  # authentication user URLS
    path('admin/', admin.site.urls),
    path('ckeditor/', include('ckeditor_uploader.urls')),
    path('grappelli/', include('grappelli.urls')),
    path('i18n/', include('django.conf.urls.i18n'))
]

urlpatterns += i18n_patterns(
    path('', include(('main.urls', 'main'), namespace='main')),
    prefix_default_language=True
)

main/models.py
from django.db import models
from django.utils import timezone
from django.utils.text import slugify
from django.utils.translation import ugettext_lazy as _
# from django.contrib.auth.models import AbstractUser

from ckeditor.fields import RichTextField
from versatileimagefield.fields import VersatileImageField, PPOIField

from project.utils import path_and_rename, random_slug_helper


class DeactivatableModelQuerySet(models.QuerySet):
    def active(self):
        return self.filter(active=True)

    def disabled(self):
        return self.filter(active=False)


class AbstractModel(models.Model):
    title = models.CharField(_('Назва'), max_length=255, null=True, blank=True,)
    active = models.BooleanField(_('Активне'), default=True, db_index=True)
    created = models.DateTimeField(_('Створено'), default=timezone.now, db_index=True)
    updated = models.DateTimeField(_('Оновлено'), auto_now=True, db_index=True)
    position = models.PositiveSmallIntegerField(_('Сортування'), null=True, default=0)

    objects = DeactivatableModelQuerySet.as_manager()  #

    class Meta:
        ordering = ['position']
        abstract = True

    def __str__(self):
        return f'{self.title}'


class ContentMixin(models.Model):

    description = RichTextField(_('Description'), null=True, blank=True, )
    image_ppoi = PPOIField()
    slug = models.SlugField(
        _('Унікальний slug сторінки'),
        unique=True,
        max_length=255,
    )
    preview = VersatileImageField(
        ppoi_field='image_ppoi',
        verbose_name=_('Прев`ю'),
        upload_to=path_and_rename,
        help_text='ще треба вирішити розміри',
    )
    published_at = models.DateTimeField(
        _('Published at'),
        null=True,
        blank=True,
        db_index=True,
    )

    def save(self, *args, **kwargs):
        if not self.slug:
            # self.slug = slugify(f'{self.title}-{random_slug_helper()}')
            self.slug = slugify(self.title)
        super().save(*args, **kwargs)

    class Meta:
        abstract = True


class Course(AbstractModel):
    description = RichTextField(_('Description'), null=True, blank=True, )
    price = models.SmallIntegerField(
        _('Ціна курсу'),
        blank=True,
        db_index=True,
    )

    class Meta:
        verbose_name = _('Курс')
        verbose_name_plural = _('Курси')


class Subject(AbstractModel, ContentMixin):
    course = models.ForeignKey(
        Course,
        verbose_name=_('Курс'),
        related_name='subjects',
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
    )

    class Meta:
        verbose_name = _('Предмет')
        verbose_name_plural = _('Предмети')


class Lesson(AbstractModel, ContentMixin):
    subject = models.ForeignKey(
        Subject,
        verbose_name=_('Предмет'),
        related_name='lessons',
        null=True,
        on_delete=models.SET_NULL,
        blank=True,
    )

    class Meta:
        verbose_name = _('Урок')
        verbose_name_plural = _('Уроки')


class LessonVideo(AbstractModel, ContentMixin):
    LOW = '480'
    MIDDLE = '720'
    HIGH = '1080'
    VIDEO_RESOLUTION = (
        (LOW, '480'),
        (MIDDLE, '720'),
        (HIGH, '1080'),
    )
    quality = models.CharField(
        _('Якість відео'),
        max_length=50,
        choices=VIDEO_RESOLUTION,
        db_index=True
    )
    lesson = models.ForeignKey(
        Lesson,
        verbose_name=_('Урок'),
        related_name='videos',
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
    )
    video_file = models.FileField(upload_to=path_and_rename)

    class Meta:
        verbose_name = _('Відео уроку')
        verbose_name_plural = _('Відео уроків')


# class User(AbstractUser):
    # sex = models.CharField()
    # birthday = models.DateField()
    # phone_number = models.CharField()
    # my_courses = models.ManyToManyField()
    # my_photo = models.ImageField(
    #     upload_to='path_and_rename',
    #     height_field=None,
    #     width_field=None,
    # )

main/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.utils.translation import gettext_lazy as _

from main.models import Course, Subject, Lesson


def index(request):
    course = Course.objects.active().first()
    # subjects_list = Subject.objects.active().filter(course=course).order_by('position') # саме той курс course
    subjects_list = []
    if course:
        subjects_list = course.subjects.active().order_by('position')  # related_name = subjects
    # queryset з всіма Subjects, що посилаються на цей курс
    # course.subjects  -  related_name='subjects'  в models.Subject
    # це екземпляр ModelQuerySet сортування,спочатку по position '-' зворотній напрямок
    template_name = 'main/index.html'
    context = {
            'title': _('Головна сторінка курсу'),  # вставити всюди де є текстові фрази
            'subjects_list': subjects_list,  # ModelQuerySet перетворюється всередині шаблону в список
            'course': course,
        }
    return render(request, template_name=template_name, context=context)


def subject_page(request, pk):
    queryset = Subject.objects.active()  # тільки активні предмети
    subject = get_object_or_404(queryset, pk=pk)  # get_object_or_404 витягає з бази об'єкт по pk
    lessons_list = subject.lessons.active().order_by('position')  # список всіх активних уроків, що посилаються на цей subject
    return render(
        request,
        'main/subject_page.html',
        {
            'subject': subject,
            'lessons_list': lessons_list
        }
    )


def lesson_page(request, pk):
    queryset = Lesson.objects.active()  # тільки активні уроки
    lesson = get_object_or_404(queryset, pk=pk)  # get_object_or_404 витягає з бази об'єкт по pk

    lesson_videos = lesson.videos.active().order_by('position')
    return render(
        request,
        'main/lesson_page.html',
        {
            'lesson': lesson,
            'lesson_videos': lesson_videos
        }
    )

# class based views CBV
# get_extra_context
# class LessonDetailView(views.GenericDetailView):

main/templates/main/base.html
<!DOCTYPE html>
{% load i18n %}
<html lang="uk">
    <head>
        <meta charset="UTF-8">
        <title>Школа Леді</title>
    </head>
    <body>
        <form action="{% url 'set_language' %}" method="post">
            {% csrf_token %}
            <input name="next" type="hidden" value="{{ redirect_to }}">
            <select name="language">
                {% get_current_language as LANGUAGE_CODE %}
                {% get_available_languages as LANGUAGES %}
                {% get_language_info_list for LANGUAGES as languages %}
                {% for language in languages %}
                    <option value="{{ language.code }}"
                        {% if language.code == LANGUAGE_CODE %}
                            selected
                        {% endif %}>
                        {{ language.name_local }} ({{ language.code }})
                    </option>
                {% endfor %}
            </select>
            <input type="submit" value="{% trans 'Змінити' %}">
        </form>
        {% block content %} {% endblock %}
    </body>
</html>

main/templates/main/index.html
{% extends 'main/base.html' %}

{% load i18n account %}

{% block content %}

    <h1>{% trans 'Назва курсу' %}:
        {{ course.title }}
    </h1>

    <p>{% trans 'Опис курсу' %}:</p>
        {{ course.description|safe }}

    <p>{% trans 'Ціна курсу' %}:
        {{ course.price }}
        {% trans 'грн' %}
    </p>

    <p>{% trans 'Предмети в курсі' %}:</p>

    {% for subject in subjects_list %}
        <a href="{% url 'main:subject-page' subject.id %}" title="{{ subject.title }}">
            <img src="{{subject.preview.url}}" alt="{{ subject.title }}" width="300">
            <br>
            {{ subject.title }}
        </a><br>
    {% endfor %}
{% endblock %}

main/templates/main/lesson_page.html
{% extends 'main/base.html' %}

{% load i18n %}

{% block content %}
    <img src="{{lesson.preview.url}}" alt="{{ lesson.title }}" width="90" height="90">
    <h1> {% trans 'Назва уроку' %}:
        {{ lesson.title }}
    </h1>
    <p>{% trans 'Опис уроку' %}: {{ lesson.description|safe }}</p>

    <p>
        {% trans 'Відео уроку' %}:
    </p>

    {% for video in lesson_videos %}
        <p>
            <video controls autoplay>
                <source src="{{ video.video_file.url }}">
            </video>
        </p>
    {% endfor %}
{% endblock %}

main/templates/main/subject_page.html
{% extends 'main/base.html' %}

{% load i18n %}

{% block content %}
    <h1> {% trans 'Назва предмету' %}: {{ subject.title }}
    </h1>

    <p>
       {% trans 'Опис предмету' %}: {{ subject.description|safe }}
    </p>
    <p>
        {% trans 'Уроки предмету' %}:
    </p>

    {% for lesson in lessons_list %}
        <p>
            <a href="{% url 'main:lesson-page' lesson.id %}">
                <img
                    src="{{lesson.preview.url}}"
                    alt="{{ lesson.title }}"
                    width="300">
                {{ lesson.title }}
            </a>
        </p>
    {% endfor %}

{% endblock %}